#!/bin/bash -l
#SBATCH --job-name="alpha_GW_BSE"
#SBATCH --nodes=
#SBATCH --ntasks-per-node=
#SBATCH --cpus-per-task=
VASP=
GW=" NELM = 8 ; ALGO = GW ; NEDOS = 2001 ; ANTIRES  = 1 ;  NMAXFOCKAE = 2 "
FXC=HAT
KPAR=
#for cloud users: need to check VASP documentation/get in contact with VASP team for vertex corrections, default is RPA, and the VASP keywords may have changed between versions
case "$FXC" in 
    RPA)  KERNEL="LFXCEPS=.FALSE. ;" ;;
	NQ)   KERNEL="LADDER=.TRUE. ; LUSEW = .TRUE. ;" ;; 
	HAT)  KERNEL="LFXCEPS=.TRUE. ; LFXC = .TRUE. ; LTCTE = .TRUE. " ;;
esac

NOMEGA=
NBANDSGW=

TODO=BASIS

#This is material specific, needed for kpoints grid averaging scheme
data[1]="0.000000 0.000000 0.000000"
data[2]="0.250000 0.00000 -0.000000"
data[3]="0.500000 0.00000 -0.000000"
data[4]="0.250000 0.25000 -0.000000"
data[5]="0.500000 0.250000 -0.000000"
data[6]="-0.250000 0.250000 0.000000"
data[7]="0.250000 0.50000 -0.000000"
data[8]="0.500000 0.50000 -0.000000"
data[9]="0.250000 0.250000 0.250000"
data[10]="-0.250000 0.250000 0.250000"
data[11]="0.500000 0.500000 0.250000"
data[12]="-0.250000 0.500000 0.250000"
data[13]="-0.250000-0.250000 0.250000"
data[14]="0.500000 0.500000 0.500000"

param=1.0
NKPT=4
#need to loop over all irreducible k-points then do weighted average for spectra. check literature. only showing one example here
for i in 1
do
rm WAVECAR* WAVEDER*
rm W* CHG*
  cat >KPOINTS <<!
Automatically generated mesh
       0
Gamma
  $NKPT $NKPT $NKPT
${data[$i]}
!
	ENMAX=`grep ENMAX  POTCAR  | sort -k3 | awk '{print $3}' | tail -1`
	ENMAXRED="${ENMAX:0:3}"
	ENCUT=`echo "scale = 0; $ENMAXRED*$param / 1" |bc -l`
	echo $ENCUT
	#===========================================================
	#                           SCAN
	#==========================================================
	#Ease convergence by starting with small NBANDS then increasing
	NBANDS=
        echo "EDIFF = 1E-6" > INCAR
        echo "ALGO = ALL ; METAGGA = R2SCAN ; LASPH = T ; LMAXMIX = 4 ; PREC = A">> INCAR
        echo "ISPIN = 2" >> INCAR
        echo "ISMEAR = 0 ; SIGMA = 0.02 ;" >> INCAR
        echo "MAGMOM = 3.0 -3.0 -3.0 3.0 8*0" >> INCAR
        echo "ISYM = -1" >> INCAR
        echo "LORBIT = 11" >> INCAR
        echo "ENCUT = $ENCUT" >> INCAR
        echo "NBANDS = $NBANDS" >>INCAR
        echo "KPAR = $KPAR" >> INCAR
        $VASP
        cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.SCAN

	NBANDS=
	echo "EDIFF = 1E-6 ; NELMIN = 15 ; NCORE = 12" > INCAR
        echo "ALGO = ALL ; METAGGA = R2SCAN ; LASPH = T ; LMAXMIX = 4 ; PREC = A">> INCAR        
	echo "ISPIN = 2" >> INCAR
        echo "ISMEAR = 0 ; SIGMA = 0.02 ;" >> INCAR
        echo "MAGMOM = 3.0 -3.0 -3.0 3.0 8*0" >> INCAR
        echo "ISYM = -1" >> INCAR
        echo "LORBIT = 11" >> INCAR
        echo "ENCUT = $ENCUT" >> INCAR
        echo "LOPTICS = .TRUE." >>INCAR
        echo "NBANDS = $NBANDS" >>INCAR
        echo "KPAR = $KPAR" >> INCAR
        $VASP
        cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.SCAN

        #===========================================================
        #                           evGW
        #==========================================================
	echo "EDIFF = 1E-7" > INCAR
	echo "ENCUT = $ENCUT" >> INCAR
	echo "ISMEAR = 0 ; SIGMA = 0.02 ; IMIX = 0 " >> INCAR
	echo "ISPIN = 2" >> INCAR
	echo "ISYM = -1" >> INCAR
	echo "$GW " >> INCAR
	echo "$KERNEL " >> INCAR
	echo "LORBIT = 11" >> INCAR
	echo "KPAR = $KPAR " >>INCAR
	echo "NBANDS = $NBANDS" >>INCAR
	echo "NBANDSGW = $NBANDSGW" >>INCAR
	echo "LOPTICS = .TRUE." >>INCAR
	echo "NOMEGA = $NOMEGA" >>INCAR
	$VASP
	cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.QPGW_$FXC
	cp vasprun.xml vasprun.QPGW_$FXC.xml
        #===========================================================
        #                           RPA
        #==========================================================
	echo "PREC = Normal ; ENCUT = $ENCUT" > INCAR
	echo "ALGO = BSE ; LADDER = .FALSE. ; LHARTREE = .TRUE. ; ANTIRES = 0" >> INCAR
	echo "ISMEAR = 0 ; SIGMA = 0.01 ;" >> INCAR
	echo "NBANDS = $NBANDS" >> INCAR
	echo "NBANDSO =  ; NBANDSV = " >> INCAR
	echo "OMEGAMIN =  ; OMEGAMAX =  ; NOMEGA = " >> INCAR
	echo "ISYM = -1 ; PRECFOCK = " >> INCAR
        $VASP
        cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.RPA
        cp vasprun.xml vasprun.RPA.xml

        #===========================================================
        #                           BSE
        #==========================================================
        echo "PREC = Normal ; ENCUT = $ENCUT" > INCAR
        echo "ALGO = BSE ; ANTIRES = 0" >> INCAR
        echo "ISMEAR = 0 ; SIGMA = 0.01" >> INCAR
        echo "NBANDS = $NBANDS" >> INCAR
        echo "NBANDSO =  ; NBANDSV = " >> INCAR
        echo "OMEGAMIN =  ; OMEGAMAX =  ; NOMEGA = " >> INCAR
        echo "ISYM = -1 ; PRECFOCK = " >> INCAR
        $VASP
        cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.BSE
	cp vasprun.xml vasprun.BSE.xml
 done
fi
