#!/bin/bash
#SBATCH -J alpha_MnO2_GW
#SBATCH -t
#SBATCH --nodes=
#SBATCH --ntasks-per-node=
#SBATCH --cpus-per-task=
#SBATCH --qos=
#SBATCH --partition=
VASP=
QPGW=" NELM = 20 ; ALGO = QPGW ; NEDOS = 2001 ;  ANTIRES  = 1 ;  NMAXFOCKAE = 2 "
KPAR= 
NCPU=$SLURM_NTASKS
NBANDSGW=
NOMEGA=

TODO=BASIS


if [ $TODO == "BASIS" ];
then
#setup KPOINTS
cat >KPOINTS <<!
Automatically generated mesh
0
Gamma
2 2 2
0 0 0 
!
#param is the multiplier for the cutoff, can loop over several cutoffs but have to save files with different names
for param in 1.0
do
        rm W* CH*
	ENMAX=`grep ENMAX  POTCAR  | sort -k3 | awk '{print $3}' | tail -1`
	ENMAXRED="${ENMAX:0:3}"
	ENCUT=`echo "scale = 0; $ENMAXRED*$param / 1" |bc -l`
	echo $ENCUT
	#===========================================================
	#                           PBE
	#==========================================================
        echo "EDIFF = 1E-6" > INCAR
	echo "ISMEAR = 0 ; SIGMA = 0.02 ;" >> INCAR
        echo "KPAR = $KPAR" >> INCAR
        echo "ISPIN = 2" >> INCAR
        echo "MAGMOM = 3.0 -3.0 -3.0 3.0 8*0" >> INCAR
	echo "ENCUT = $ENCUT" >> INCAR
	$VASP
	cat INCAR OUTCAR > OUTCAR.PBE.PRELIM
       
	NBANDS=`awk -v xx=$NCPU ' /maximum number of plane-waves:/ { print int(($5)/xx)*xx } ' <OUTCAR.PBE.PRELIM`
	echo "KPAR = $KPAR" > INCAR
	echo "EDIFF = 1E-7" >> INCAR
	echo "ALGO = Exact  ">> INCAR
	echo "NELM = 100" >> INCAR
	echo "ISPIN = 2" >> INCAR
	echo "ISMEAR = 0 ; SIGMA = 0.02 ;" >> INCAR
	echo "MAGMOM = 3.0 -3.0 -3.0 3.0 8*0" >> INCAR
	echo "LORBIT = 11" >> INCAR
	echo "ENCUT = $ENCUT" >> INCAR
	echo "LOPTICS = .TRUE." >>INCAR
	echo "NBANDS = $NBANDS" >>INCAR
        $VASP	

        #===========================================================
        #                           QSGW
        #==========================================================	
	echo "ENCUT = $ENCUT" >> INCAR
	echo "ISMEAR = 0 ; SIGMA = 0.02 ;" >> INCAR
	#echo "ENCUTGW = $ENCUTGW" >> INCAR
	echo "ISPIN = 2" >> INCAR
	echo "$QPGW " >> INCAR
	echo "LORBIT = 11" >> INCAR
	echo "KPAR = $KPAR " >>INCAR
	echo "NBANDS = $NBANDS" >>INCAR
	echo "NBANDSGW = $NBANDSGW" >>INCAR
	echo "LOPTICS = .TRUE." >>INCAR
	echo "LPEAD = .TRUE." >>INCAR
	echo "NOMEGA = $NOMEGA" >>INCAR
	$VASP
	cat INCAR OUTCAR > OUTCAR.$ENCUT.$NBANDS.QPGW
	mv PROCAR PROCAR.$ENCUT.$NBANDS.QPGW
	mv DOSCAR DOSCAR.$ENCUT.$NBANDS.QPGW
	mv CHGCAR F_CHGCAR.$ENCUT.$NBANDS.QPGW
        mv WAVECAR F_WAVECAR.$ENCUT.$NBANDS.QPGW
        mv vasprun.xml vasprun.$ENCUT.$NBANDS.QPGW.xml
 done
fi
